#include	"mview.h"
#include	"mdir.h"
#include	<HS_wlib.h>
#include	<string.h>

extern int	FormatstringD( char*, DIRNAME* );
extern int	SendCheck( char* );
extern int	MailExec( WindowID, EventInfo* );
extern DirKey( WindowID, EventInfo* );

static int	DirExec( WindowID, EventInfo* );
void	DirChange( WindowID, int );

#include	"mbarm2.c"
#include	"mbars2.c"

void
DirChange( wp, y )
WindowID	wp;
int	y;
{
	int	i= -1;
	
	if( MailNow )	SaveInf();	/* ǏȂǂ̕ۑ */
	strcpy( CDir, Env.Mailbox );
	strcat( CDir, dirdescend( DirList[y] ) );
	strcat( CDir, "\\" );
	SendFlag= SendCheck( DirList[y]->name );
	TrashFlag= ( !strcmpi( DirList[y]->name, "TRASH" ) )? 1:0;
	DirPos= y;
	if( DirList[y]->flag == '+' && ( i= DIRGET( CDir, DirList[y] ) ) ){
		WindowClose( Dwp );
		WindowScrollOpen( 0, 0 + BUTTON_V, 120, 244, Bwp, 120,
					(DirNow*FONT_V<=240)? 240:DirNow*FONT_V,
					DirectionY, 16, FONT_V, DirExec );
	}else {
		if( !i )	DirList[y]->flag= ' ';
		WindowRedraw( wp );
	}
	WindowClose( Mwp );
	FILEGET();
	Mwp= WindowScrollOpen( 120, 0 + BUTTON_V, 392, 244, Bwp, 392,
			(MailNow*FONT_V<=240)? 240:MailNow*FONT_V, DirectionY, 16, FONT_V, MailExec );
	if( !MailNow )	Dir= 0;
}


static int
DirExec( wp, info )
WindowID wp;
EventInfo *info;
{
	DrawBuf	dbuf[22+2], *dp= dbuf;
	char	buf[22][40];
	
	switch( info->option ){
	case EventOpen:
    		WindowSetEventAttr( wp, EventAttrDefault );
		Dwp= wp;
		WindowRedraw( Dwp );
		return TRUE;

	case EventRedraw:
	{
		int	i, j, k, attr;

		if( DirNow < 20 )	DrawSetClear( dp++, 1 );
		i= HS_WindowGetHomeY( wp );
		if( DirCurPos < i || DirCurPos >= i + 20 )	DirCurPos= i;
		if( i )	i-= 1;
		for( j= 0; i < DirNow && j < 22; i++, j++ ){
			attr= (i == DirPos)? (AttrDefault ^ 8):AttrDefault;
			if( i == DirCurPos )	attr|= AttrUnderLine;
			k= FormatstringD( buf[j], DirList[i] );
			DrawSetSymbol( dp++, k, i * 12, buf[j], attr, 12 );
		}
		WindowDraw( wp, dbuf, dp - dbuf );
		if( SendFlag ){
			DrawSetPut( dp, 0, 0, &Mbars2Pattern );
		}else {
			DrawSetPut( dp, 0, 0, &Mbarm2Pattern );
		}			
		WindowDraw( Bwp, dp, 1 );
		return TRUE;
	}

	case EventClose:
		WindowClose( wp );
		Dwp= NULL;
		return TRUE;

	case EventMouseSwitch:{
		int	y= info->y / 12;

		if( !info->LeftON || y > DirNow )	return TRUE;
		DirCurPos= y;
		DirChange( wp, y );
		return TRUE;
	}
	}
	return FALSE;
}


int
MainExec( wp, info )
WindowID wp;
EventInfo *info;
{
	DrawBuf	dbuf[1];

	switch( info->option ){
	case EventOpen:
		Bwp= wp;
		WindowSetEventAttr( wp, EventAttrDefault );
		Dwp= NULL;
		strcpy( CDir, Env.Mailbox );
		DirList= NULL;
		DirNow= 0;					/* fBNg */
		DirCurPos= 0;
		DirPos= 0;					/* J[\ʒu */
		if( DIRGET( CDir, NULL ) ){;	/* xZbg */
			WindowRedraw( wp );
			WindowScrollOpen( 0, 0 + BUTTON_V, 120, 244, wp, 120,
						(DirNow * FONT_V <= 240) ?240:DirNow*FONT_V,
						DirectionY, 16, FONT_V, DirExec );
			strcat( CDir, dirdescend( DirList[DirPos] ) );
			strcat( CDir, "\\" );
			FILEGET();
			Mwp= WindowScrollOpen( 120, 0 + BUTTON_V, 392, 244, wp, 392,
					(MailNow * FONT_V <= 240)? 240 : (MailNow * FONT_V),
					DirectionY, 16, FONT_V, MailExec );
		}else {
			ConsoleOpen();
			ConsolePrint( "mview : [{bNXɃfBNg܂\n" );
			WindowConnectionClose();
		}
		return TRUE;

	case EventRedraw:
		DrawSetClear( dbuf, 1 );
		WindowDraw( wp, dbuf, 1 );
		if( Dwp )	WindowRedraw( Dwp );
		if( Mwp )	WindowRedraw( Mwp );
		return TRUE;

	case EventClose:
		WindowClose( wp );
		quitop();
		return TRUE;

	case EventMouseSwitch:

		if( info->y <= BUTTON_V ){
			buttonop( wp, info );
		}else if( info->y <= 244 + BUTTON_V ){
			info->y-= BUTTON_V;
			if( info->x <= 120 ){
				return WindowSendEvent( Dwp, info );
			}else {
				info->x-= 120;
				return WindowSendEvent( Mwp, info );
			}
		}
		return FALSE;

	case EventKey:
		if( Dir ){
			return MainCont( info );
		}else {
			return DirKey( Dwp, info );
		}

	case EventIconify:
		IconEnt( wp, "mview", AttrDefault|AttrHighLight, 16 );
		return TRUE;
	}
	return FALSE;
}

void
mesprint( message )
char	*message;
{
	DrawBuf	dbuf[2];

	if( !Bwp )	return;
	
	DrawSetLine( dbuf, 0, 242 + 4 + BUTTON_V,  511, 254 + 4 + BUTTON_V, 1, OptionFill );
	DrawSetSymbol( dbuf + 1, 0, 242 + 4 + BUTTON_V, message, AttrDefault, 12 );
	WindowDraw( Bwp, dbuf, 2 );
}
