#include	"mview.h"
#include	"window.h"
#include	<HS_wlib.h>
#include	<io.h>
#include	<string.h>

#define		Ctrl(a)	((a)&0x1f)
#define		CFN(a)	((a)|0x200)
#define		Esc(a)	((a)|0x100)

static WindowID	Swp;
static int	OnSwitch, TargetMen;

static void	WinMark( WindowID, int );
static void	cursormove( WindowID, int );
static int	WinKey( WindowID, EventInfo* );
static int	WinScExec( WindowID, EventInfo* );
static int	WinExec( WindowID, EventInfo* );

static char	subtitle[STR_MAX];


static void
WinMark( wp, i )
WindowID	wp;
int	i;
{
	DrawBuf	dbuf[2], *dp= dbuf;
	int	attr;

	if( OnSwitch ){			/* I */
		attr= (WinOn[TargetMen])? (AttrDefault ^ 8):AttrDefault;
		DrawSetSymbol( dp++, 0, TargetMen * 12, WinMember[TargetMen].name,
						attr, 12 );
		attr= AttrDefault | AttrUnderLine;
		if( WinOn[i] ){
			WinOn[i]= 0;
			WinOnNum--;
		}else {
			WinOn[i]= 1;
			WinOnNum++;
			attr^= 8;
		}
		DrawSetSymbol( dp++, 0, i * 12, WinMember[i].name, attr, 12 );
	}else {
		WinOn[TargetMen]= 0;
		WinOn[i]= 1;
		DrawSetSymbol( dp++, 0, TargetMen * 12, WinMember[TargetMen].name,
					AttrDefault, 12 );
		DrawSetSymbol( dp++, 0, i * 12, WinMember[i].name,
					AttrDefault ^ 8, 12 );
	}
	TargetMen= i;
	WindowDraw( wp, dbuf, dp - dbuf );
}


static void
cursormove( wp, y )
WindowID	wp;
int	y;
{
	if( !OnSwitch ){
		WinMark( wp, y );
	}else {
		DrawBuf	dbuf[2], *dp= dbuf;
		int	attr, i= 2;

		attr= AttrDefault;
		while( i-- ){
			if( WinOn[TargetMen] )	attr^= 8;
			DrawSetSymbol( dp++, 0, TargetMen * 12, WinMember[TargetMen].name, attr, 12 );

			TargetMen= y;
			attr= AttrDefault | AttrUnderLine;
		}
		WindowDraw( wp, dbuf, dp - dbuf );

	}
}


/* L[샋[` */
int
WinKey( wp, info )
WindowID wp;
EventInfo *info;
{
	unsigned int Key= info->KeyCode;
	int	i, y;

	y= HS_WindowGetHomeY( wp ) / 12;
	if( Key >= FuncKey && (info->ShiftStat & 2) )
		Key |= 0x200;

	switch( Key ){
	case FuncKeyUp:
	case Ctrl('e'):
	case Ctrl('p'):
		if( TargetMen ){	/* uv */
			i= TargetMen - 1;
			cursormove( wp, i );
			if( WinMax > 15 && i < y ){
				/* 炵ĂXN[ */
				WindowScroll( wp, 0, -12 );
			}
		}
		break;

	case ' ':			/* }[N */
		if( !OnSwitch )	break;
		WinMark( wp, TargetMen );

	case FuncKeyDown:
	case Ctrl('n'):
	case Ctrl('x'):
		i= TargetMen + 1;
		if ( i < WinMax ) {	/* uv */
			cursormove( wp, i );
			if( WinMax > 15 && i >= y + 15 ){
				/* 炵ĂXN[ */
				WindowScroll( wp, 0, 12 );
			}
		}
		break;

	case FuncKeyRollDown:	/* uROLL DOWNv */
	case Ctrl( 'r' ):
	case Ctrl( 'z' ):
		if( TargetMen ){
			i= TargetMen - 14;
			if( i < 0 ){	/* Eяo␳ */
				i= 0;
			}
			cursormove( wp, i );
			if( y && WinMax > 15 ){ /* [? */
				WindowScroll( wp, 0, -12 * 14 );	/* Py[Wړ */
			}
		}
		break;

	case FuncKeyRollUp:		/* uROLL UPv */
	case Ctrl('v'):
	case Ctrl('c'): 
		if( TargetMen != WinMax - 1 ){
			i= TargetMen + 14;
			if( i >= WinMax ){	/* Eяo␳ */
				i = WinMax - 1;
			}
			cursormove( wp, i );
			if( WinMax > 15 && y + 15 <=  WinMax ){/* I[? */
				WindowScroll( wp, 0, 12 * 14 );	/* Py[Wړ */
			}
		}
		break;
	}
	return TRUE;
}


void
winlist( wild, attr )
char	*wild;
int	attr;
{
	char	files_buffer[150],		/* files(fBNg)p */
			files_atr;
	int	files_date;
	size_t	files_len;
	char	*FoundFile;

	FoundFile= files( files_buffer, &files_atr, &files_date, &files_len, wild, attr );
	while( FoundFile ){			/* A */
		if( strcmp( FoundFile, "." ) && strcmp( FoundFile, ".." ) ){
			strcpy( WinMember[WinMax++].name, FoundFile );
		}
	 	FoundFile= nfiles( files_buffer, &files_atr, &files_date, &files_len );
	}
	return;
}

int
WinScExec( wp, info )
WindowID wp;
EventInfo *info;
{
	DrawBuf	dbuf[15 + 2 + 1], *dp= dbuf;
	int	i;
	
	switch( info->option ){
	case EventOpen:
		for( i= 0; i < WinMax; i++ )	WinOn[i]= 0;
		TargetMen= 0;	/* 0ԂftHgőI */
		if( !OnSwitch ){
			WinOnNum= 1;
			WinOn[0]= 1;	/* }[N */
		}
		Swp= wp;
		return TRUE;
	case EventRedraw:
	{
		int	j, attr;

		DrawSetClear( dp++, 1 );
		i= HS_WindowGetHomeY( wp ) / 12;
		if( TargetMen < i || TargetMen >= i + 15 ){
			if( !OnSwitch ){
				WinOn[TargetMen]= 0;
				WinOn[i]= 1;
			}
			TargetMen= i;
		}
		if( i )	i-= 1;
		for( j= 0; i < WinMax && j < 15 + 2; i++, j++ ){
			attr= ( WinOn[i] )? (AttrDefault ^ 8):AttrDefault;
			if( i == TargetMen ) attr|= AttrUnderLine;
			DrawSetSymbol( dp++, 0, i * 12, WinMember[i].name,
							attr, 12 );
		}
		WindowDraw( wp, dbuf, dp - dbuf );
		return TRUE;
	}
	case EventClose:
		WindowClose( wp );
		return TRUE;

	case EventMouseSwitch:
		if( info->LeftON && (i= info->y / 12) < WinMax ){
			WinMark( wp, i );
		}
		return TRUE;
	}
	return FALSE;
}

int
WinExec( wp, info )
WindowID	wp;
EventInfo	*info;
{
	DrawBuf	dbuf[5 + 2], *dp= dbuf;

	switch( info->option ){
	case EventOpen:
		WinOnNum = 0;
		WindowSetEventAttr( wp, EventAttrDefault );
		WindowScrollOpen( 0, 0 + 14, 150, 184, wp, 150,
					(WinMax * FONT_V < 180)? 180:(WinMax * FONT_V),
					DirectionY, 16, FONT_V, WinScExec );
		WindowRedraw( wp );
		return	TRUE;
	case EventClose:
		WindowClose( Swp );
		WindowClose( wp );
		return TRUE;
	case EventRedraw:
		DrawSetClear( dp++, 1 );
		DrawSetLine( dp++, 0, 0, 149, 12, 0, OptionFill );
		DrawSetSymbol( dp++, 0, 1, subtitle, 3, 12 );
		DrawSetSymbol( dp++, 18, 184 + 4 + 14, "  Ok  ", AttrDefault, 12 );
		DrawSetSymbol( dp++, 98, 184 + 4 + 14, "Cancel", AttrDefault, 12 );
		DrawSetLine( dp++, 16, 182 + 4 + 14,  55, 197 + 4 + 14, ShadowUp, OptionShadow );
		DrawSetLine( dp++, 96, 182 + 4 + 14, 135, 197 + 4 + 14, ShadowUp, OptionShadow );
		WindowDraw( wp, dbuf, dp - dbuf );
		WindowRedraw( Swp );
		return	TRUE;
	case EventMouseSwitch:
		if( info->y >= 14 && info->y < 184 + 14){
			info->y -= 14;
			return WindowSendEvent( Swp, info );
		}
		return TRUE;
	case EventKey:
		info->y -= 14;
		return WinKey( Swp, info );
	}
	return	FALSE;
}

static EventInfo	myinfo;

int
WinManager( title, mode )
char	*title;
int	mode;
{
	WindowID	cwp, nwp;

	int	x, y;
	
	strcpy( subtitle, title );
	OnSwitch= mode;
	WindowGetScreenPosition( Bwp, &x, &y );
	cwp= WindowSimpleOpen( x + WINDOW_X, y + WINDOW_Y, 150, 204 + 14, NULL, WinExec );

	for(;;){
/*		if( !WindowGetEventInfo( &myinfo ) )	continue;*/
		WindowGetEventInfo( &myinfo );
		nwp= WindowGetChild( WindowRootID, &myinfo );
		if( myinfo.option == EventKey && ( nwp == cwp || nwp == Bwp ) ){
			if( myinfo.KeyCode == '\r' ){
				break;	/* RET */
			}else if( myinfo.KeyCode == '\x1b' ){
				TargetMen= -1;
				break;	/* ESC */
			}else {
				WindowSendEvent( cwp, &myinfo );
			}
		}else if( nwp == cwp ){
			if( myinfo.option == EventClose ){
				TargetMen= -1;
				break;
			}
			if( myinfo.LeftON && myinfo.y >182 + 4 + 14
					&& myinfo.y < 197 + 4 + 14 ){
				if( myinfo.x > 16 && myinfo.x < 55 ){
					break;	/* OK */
				}else if( myinfo.x > 96 && myinfo.x < 135 ){
					TargetMen= -1;
					break;	/* Cancel */
				}
			}else {
				WindowSendEvent( cwp, &myinfo );
			}
		}else if( nwp != Bwp ){
			WindowSendEvent( nwp, &myinfo );
		}
	}
	WindowClose( cwp );
	return TargetMen;
}
